<id>
OnlineActivity 4 YaBB231
</id>

<version>
0.3 beta
</version>

<mod info>

This mod adds a "Online Activity" area to the info center on the Board Index page
listing the users activities on the forum. Admin option to set permissions.

For YaBB 2.3.1

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Admin/NewSettings.pl
cgi-bin/yabb2/Admin/Settings_Advanced.pl

cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Languages/English/BoardIndex.lng

cgi-bin/yabb2/Sources/BoardIndex.pl
cgi-bin/yabb2/Sources/LogInOut.pl
cgi-bin/yabb2/Sources/Subs.pl

cgi-bin/yabb2/Templates/default/BoardIndex.template


Go to "Admin Center > Advanced Settings > Advanced" and set the "Online Activity" settings.

</mod info>

<author>
Carsten
</author>


<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$onlineactivity_mod = "OnlineActivity_4_YaBB231|Carsten|This mod adds a \"Online Activity\" area to the info center on the Board Index page listing the users activities on the forum.|0.3 beta|03/18/09";
	push (@installed_mods, "$onlineactivity_mod");

</add before>


<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$elrotate = $elrotate;					# Allow for log rotation
</search for>

<add after>

########### Online Activity ################

\$enableactivlog  = $enableactivlog;			# Permissions for Online Activity view
\$guestactivity  = $guestactivity;			# Set to 1 to enable Guest activity
</add after>


<edit file>
Admin/Settings_Advanced.pl
</edit file>

<search for>
		{
			description => $admin_txt{'630'},
			input_html => qq~<input type="checkbox" name="faketruncation" value="1" ${ischecked($faketruncation)}/>~,
			name => 'faketruncation',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			header => $activity_txt{'1'},
		},
		{
			description => $activity_txt{'2'},
			input_html => qq~
			<select name="enableactivlog" size="1">
			<option value="0"${isselected($enableactivlog == 0)}>$activity_txt{'3'}</option>
			<option value="1"${isselected($enableactivlog == 1)}>$activity_txt{'4'}</option>
			<option value="2"${isselected($enableactivlog == 2)}>$activity_txt{'5'}</option>
			<option value="3"${isselected($enableactivlog == 3)}>$activity_txt{'6'}</option>
			<option value="4"${isselected($enableactivlog == 4)}>$activity_txt{'7'}</option>
			</select>~,
			name => 'enableactivlog',
			validate => 'number',
		},
		{
			description => $activity_txt{'8'},
			input_html => qq~<input type="checkbox" name="guestactivity" value="1" ${ischecked($guestactivity)}/>~,
			name => 'guestactivity',
			validate => 'boolean',
		},
</add after>


<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
%errorlog = (
</search for>

<add before>
%activity_txt = (
'1' => 'Online Activity',
'2' => 'Enable Online Activity for:',
'3' => 'Disable',
'4' => 'Guests +',
'5' => 'Members +',
'6' => 'GMods +',
'7' => 'Admin',
'8' => 'Enable Guest activity.',
);

</add before>


<edit file>
Languages/English/BoardIndex.lng
</edit file>

<search for>
1;
</search for>

<add before>
%activitytxt = (
'activity' => 'Online Activity',
'visiting' => 'is visiting',
'boardindex' => 'Board Index',
'catselect' => 'category',
'board' => 'board',
'num' => 'topic',
'action' => 'page',
'help' => 'Help',
'search' => 'Search',
'ml' => 'Member List',
'membermap' => 'Member Map',
'mycenter' => 'His/Her User CP',
'myusersrecentposts' => 'His/Her User CP',
'myviewlocation' => 'His/Her User CP',
'myviewprofile' => 'His/Her User CP',
'myprofile' => 'His/Her User CP',
'profile' => 'His/Her Profile',
'viewprofile' => 'a View Profile',
'im' => 'Personal Message',
'imdraft' => 'Personal Message - Draft',
'imoutbox' => 'Personal Message - Outbox',
'imsend' => 'Send Personal Message',
'favorites' => 'Favorites',
'shownotify' => 'Notification',
'usersrecentposts' => 'Users Recent Posts',
'recent' => 'Forum Recent Posts',
'RSSrecent' => 'Forum Recent Topics RSS feed',
'unknown' => 'Undefined',
);

%profileactivitytxt = (
'myprofile' => 'editing',
'myprofileAdmin' => 'editing',
'myprofileBuddy' => 'editing the Buddylist',
'myprofileContacts' => 'editing the contact information',
'myprofileIM' => 'editing the PM options',
'myprofileLocation' => 'editing the location information',
'myprofileOptions' => 'editing the options',
'profile' => 'editing',
'profileAdmin' => 'editing',
'profileLocation' => 'editing the location information',
'profileBuddy' => 'editing the Buddylist',
'profileContacts' => 'editing the contact information',
'profileIM' => 'editing the PM options',
'profileOptions' => 'editing the options',
);

%boardactivitytxt = (
'boardnotify' => 'managing Notification',
'post' => 'starting',
'StartNewTopic' => 'a new Topic',
'CreatePoll' => 'a new Poll',
'modify' => 'Modifying a Reply',
);

%topicactivitytxt = (
'post' => 'adding',
'PostReply' => 'a Reply',
'AddPoll' => 'a Poll',
);

</add before>


<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	undef %tmpcolors;
</search for>

<add after>

	if($enableactivlog == 1 || ($enableactivlog == 2 && !$iamguest) || ($enableactivlog == 3 && ($iamgmod || $iamadmin)) || ($enableactivlog == 4 && $iamadmin)) {
		$onactivity = qq~
		<div class="windowbg2" style="float: left; width: 100%; text-align: left; padding: 8px 0px 8px 0px;">
		<form action="$scripturl#activlog" method="post">
		<input type="hidden" name="alog" value="on" />
		<input type="submit" value="$activitytxt{'activity'}" class="small" style="vertical-align: middle;" />
		</form>
		~;
		if($FORM{'alog'}) {
			$thetime = &timeformat($date, 1);
			$onactivity .= qq~<span class="small">&nbsp; <b>$thetime</b></span><br />~;
		}
		$onactivity .= qq~
		</div>
		~;
		if($FORM{'alog'}) {
			$onactivity .= qq~
			<div class="windowbg2" style="float: left; width: 100%; text-align: left; padding-bottom: 8px; max-height: 300px; overflow: auto;">
			~;
			fopen(ALOG, "$vardir/activlog.txt");
			%activity = map /(.*)\t(.*)/, <ALOG>;
			fclose(ALOG);
			@cssvalues = ('windowbg', 'windowbg2');
			$cssnum = @cssvalues;
			$actcounter = 0;
			while (($tmpkey, $tmpvalue) = each(%activity)) {
				if ($tmpkey =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) { $tmpactivity{'2'}{$tmpkey} = $tmpvalue; }
				else { $tmpactivity{'1'}{$tmpkey} = $tmpvalue; }
			}
			undef %activity;
			while (($tkey, $tvalue) = each %tmpactivity) {
				while (($key, $value) = each %$tvalue) {
					$addpage = "";
					$addname = "";
					$islink = 0;
					$csscolor = $cssvalues[($actcounter % $cssnum)];
					(undef, $theip, $theplace) = split(/\|/, $value);
					if($key eq $theip && !$guestactivity) { next; }
					$theplace =~ s~(.*?)(\?.*?)~$2~;
					if($key eq $theip) {
						$theuser = qq~<b>Guest</b>~;
						if($iamadmin) {
							$theuser .= qq~ ($theip)~;
						}
					}
					else {
						&LoadUser($key);
						$theuser = $link{$key};
					}
					if($theplace =~ /(\?|\;)(catselect)\=(.+?)(\/|\;|$)/) {
						$thetext = $2;
						$thecat = $3;
						$islink = 1;
						unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
						$thisname = (split /\|/, $catinfo{$thecat})[0];
					}
					elsif($theplace =~ /(\?|\;)(board)\=(.+?)(\/|\;|$)/) {
						$thetext = $2;
						$theboard = $3;
						$islink = 1;
						unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
						$thisname = (split /\|/, $board{$theboard})[0];
						if($theplace =~ /(\?|\;)(action)\=(.+?)(\/|\;|$)/) {
							$addaction = $3;
							if(exists $boardactivitytxt{$addaction}) {
								$addname = qq~ $boardactivitytxt{$addaction}~;
							}
						}
						if($theplace =~ /(\?|\;)(title)\=(.+?)(\/|\;|$)/) {
							$addtitle = $3;
							if(exists $boardactivitytxt{$addtitle}) {
								$addname .= qq~ $boardactivitytxt{$addtitle}~;
							}
						}
					}
					elsif($theplace =~ /(\?|\;)(num)\=(\d{10,})(\/|\;|$)/) {
						$thetext = $2;
						$thetopic = $3;
						$islink = 1;
						fopen(MNUM, "$datadir/$thetopic.txt");
						$tmptopic = <MNUM>;
						fclose(MNUM);
						$thisname = (split /\|/, $tmptopic)[0];
						if($theplace =~ /(\?|\;)(action)\=(.+?)(\/|\;|$)/) {
							$addaction = $3;
							if(exists $topicactivitytxt{$addaction}) {
								$addname = qq~ $topicactivitytxt{$addaction}~;
							}
						}
						if($theplace =~ /(\?|\;)(title)\=(.+?)(\/|\;|$)/) {
							$addtitle = $3;
							if(exists $topicactivitytxt{$addtitle}) {
								$addname .= qq~ $topicactivitytxt{$addtitle}~;
							}
						}
					}
					elsif($theplace =~ /(\?|\;)(action)\=(.+?)(\/|\;|$)/) {
						$thetext = $2;
						$thepage = $3;
						if($thepage =~ m/^(myprofile|profile)/i) {
							$thisname = $activitytxt{$1};
							$addname .= qq~ $profileactivitytxt{$thepage}~;
						}
						else {
							$thisname = $activitytxt{$thepage};
						}
					}
					else {
						$thetext = "";
						$theplace = "";
						$thisname = $activitytxt{'boardindex'};
					}
					if(!$thisname) { $thisname = $activitytxt{'unknown'}; }
					&ToChars($thisname);
					if($islink) { $tmpplace = qq~\"<a href="$scripturl$theplace"><i>$thisname</i></a>\"~; }
					else { $tmpplace = qq~<i>$thisname</i>~; }
					$tmptext = "";
					if($thetext) { $tmptext = qq~ $activitytxt{$thetext}~; }
					$onactivity .= qq~
					<div class="$csscolor" style="float: left; width: 97%; text-align: left; padding: 2px 0px 2px 0px;">
						<span class="small" style="padding-left: 4px;">
						&#8226; $theuser $activitytxt{'visiting'} $tmpplace$tmptext$addname.
						</span>
					</div>
					~;
					$actcounter++;
				}
			}
			undef %tmpactivity;
			$onactivity .= qq~
			</div>
			~;
		}
	}
	else {
		$onactivity = "";
	}
</add after>

<search for>
	$boardindex_template =~ s/({|<)yabb mostusersdate(}|>)/$themostuserdate/g;
</search for>

<add after>
	$boardindex_template =~ s/({|<)yabb activity(}|>)/$onactivity/g;
</add after>


<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
		fclose(LOG);
		&UserAccount($username, "update", "lastonline");
</search for>

<add after>

		if ($enableactivlog) {
			fopen(ALOG, "+<$vardir/activlog.txt", 1);
			%activity = map /(.*)\t(.*)/, <ALOG>;
			seek ALOG, 0, 0;
			truncate ALOG, 0;
			delete($activity{$username});
			print ALOG map "$_\t$activity{$_}\n", keys %activity;
			fclose(ALOG);
			undef %activity;
		}
</add after>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
}

sub freespace {
</search for>

<add before>
	if ($enableactivlog) {
		if (!-e "$vardir/activlog.txt") {
			fopen(ALOG, ">$vardir/activlog.txt",1);
			fclose(ALOG);
		}
		fopen(ALOG, "+<$vardir/activlog.txt", 1);
		%activity = map /(.*)\t(.*)/, <ALOG>;
		seek ALOG, 0, 0;
		truncate ALOG, 0;
		while (($key, $value) = each(%activity)) {
			$date1 = (split /\|/, $value)[0];
			&calctime;
			if($result > ($OnlineLogTime * 60) || $key eq $user_ip) { delete($activity{$key}); }
		}
		$activity{$field} = "$date|$user_ip|$ENV{'REQUEST_URI'}";
		print ALOG map "$_\t$activity{$_}\n", keys %activity;
		fclose(ALOG);
		undef %activity;
	}

</add before>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
<br />
	{yabb sharedlogin}
</search for>

<add before>
~;
if($enableactivlog == 1 || ($enableactivlog == 2 && !$iamguest) || ($enableactivlog == 3 && ($iamgmod || $iamadmin)) || ($enableactivlog == 4 && $iamadmin)) {
$boardindex_template .= qq~
<table class="bordercolor" cellpadding="0" cellspacing="0" border="0" width="100%">
<tr>
	<td class="tabtitle" width="1%" height="25" valign="middle">
		<a name="activlog">&nbsp;</a>
	</td>
	<td class="tabtitle" width="99%" height="25" valign="middle">
		<span class="ie6alpha">$activitytxt{'activity'}</span>
	</td>
</tr>
</table>
<table class="bordercolor" cellpadding="4" cellspacing="1" border="0" width="100%">
<tr>
	<td class="windowbg" width="5%" valign="middle" align="center">
		<img src="$imagesdir/online.gif" border="0" alt="" />
	</td>
	<td class="windowbg2" valign="top">
		{yabb activity}
	</td>
</tr>
</table>

~;
}
$boardindex_template .= qq~
</add before>
